package {
    import flash.display.Sprite;
    import flash.text.*;
    import flash.utils.*;

    public class Clock extends Sprite
    {
        private var time_txt:TextField;
        
        public function Clock() {
            // TextFieldを作る
            time_txt = new TextField();
            time_txt.defaultTextFormat = new TextFormat(
                "_typeWriter", 64);
            time_txt.autoSize = TextFieldAutoSize.LEFT;
            // 表示オブジェクトコンテナに追加
            this.addChild(time_txt);
            setInterval(showTime, 1000);
        }
        private function showTime():void {
            // 時刻を取得する
            var now:Date = new Date();
            var hh:Number = now.getHours();
            var mm:Number = now.getMinutes();
            var ss:Number = now.getSeconds();
            // hh:mm:ss の書式に合わせる
            var shh:String = formatZero(hh, 2);
            var smm:String = formatZero(mm, 2);
            var sss:String = formatZero(ss, 2);
            time_txt.text = shh + ":" + smm + ":" + sss;
        }
        // 数値を0で埋めて指定の桁数に揃える関数
        private function formatZero(n:Number, keta:Number):String {
            var s:String = String(n);
            var i:int = 0;
            while (s.length < keta) {
                s = "0" + s;
            }
            return s;
        }    
    }
}
