import flash.events.MouseEvent;
import mx.controls.Button;

// 計算機に必要な記憶用変数
private var memory:Number  = 0;
private var op:String = '';
private var last_is_op:Boolean = false;

// ボタンをクリックした時
private function onClick(event:MouseEvent):void {
    var btn:Button = event.target as Button;
    var str:String = btn.label;
    // クリアボタンなら初期化
    if (str == "C") {
        clear();
        return;
    }
    // 数字ボタンなら、ディスプレイに追加
    if (str.match(/[0-9\.]/)) {
        addNum(str);
        return;
    }
    // 演算子ボタンが押されたら..
    eval(str);
}
// 値を初期化
private function clear():void {
    disp_txt.text = "";
    memory = 0;
    op = '';
    last_is_op = false;
}
// 数値を入力
private function addNum(num_str:String):void {
    if (last_is_op) disp_txt.text = '';
    disp_txt.text += num_str;
    last_is_op = false;
}
// 計算を実行
private function eval(op_new:String):void {
    if (last_is_op) {
        op = op_new;
        return;
    }
    var result:Number;
    var val1:Number = memory;
    var val2:Number = Number(disp_txt.text);
    switch (op) {
        case '+': result = val1 + val2; break;
        case '-': result = val1 - val2; break;
        case '*': result = val1 * val2; break;
        case '/': result = val1 / val2; break;
        case '%': result = val1 % val2; break;
        default : result = val2;
    }
    disp_txt.text = String(result);
    memory = result;
    op = op_new;
    last_is_op = true;
}
